## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# Generated by rust2rpm 18
# tests don't work on s390x for the time being
%ifarch s390x
%bcond_with check
%else
%bcond_without check
%endif
%global __cargo_skip_build 0

%global crate rbspy

%if 0%{?el8}
# el8 doesn't have these macros
%global __crates_url https://crates.io/api/v1/crates/
%global crates_source %{__crates_url}%{crate}/%{version}/download#/%{crate}-%{version}.crate
%global version_no_tilde %{version}
%endif

Name:           rust-%{crate}
Version:        0.8.1
Release:        %autorelease
Summary:        Sampling CPU profiler for Ruby

# Upstream license specification: MIT
License:        MIT
URL:            https://rbspy.github.io
Source:         %{crates_source}
# Vendored dependencies for EPEL, update with ./update-vendor-tarball.sh
Source1:        %{crate}-%{version}-vendor.tar.gz
# Initial patched metadata
# Drop non-Linux dependencies and add missing rbspy-testdata dependency
Patch0:         rbspy-fix-metadata.diff
# Backport of https://github.com/rbspy/rbspy/commit/d9dd0324bb816a67f07544fb9dd0f687fce27011
Patch1:         rbspy-proc-maps.patch

ExclusiveArch:  %{rust_arches}

%if 0%{?el8}
BuildRequires:  rust-toolset
%else
BuildRequires:  rust-packaging
%endif

%if %{with check}
BuildRequires:  ruby
BuildRequires:  rubygems
%endif

%global _description %{expand:
rbspy is a sampling CPU profiler for Ruby. rbspy lets you profile Ruby
processes that are already running. You give it a PID, and it starts profiling.
It's a sampling profiler, which means it's low overhead and safe to run in
production.

rbspy lets you record profiling data, save the raw profiling data to disk, and
then analyze it in a variety of different ways later on.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}

%description -n %{crate} %{_description}

%files       -n %{crate}
%license License.md
%doc README.md CONTRIBUTORS.md CODE_OF_CONDUCT.md ARCHITECTURE.md
%{_bindir}/rbspy

%prep
%autosetup -n %{crate}-%{version_no_tilde} -p1
%if 0%{?el8}
%cargo_prep -V 1
%else
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires
%endif

%build
%cargo_build

%install
%cargo_install

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Thu Nov 18 2021 Davide Cavalca <dcavalca@fedoraproject.org> 0.8.1-3
- Build for EPEL8 and fix tests

* Thu Nov 18 2021 Davide Cavalca <dcavalca@fedoraproject.org> 0.8.1-2
- Gate out tests on s390x for now

* Thu Nov 18 2021 Davide Cavalca <dcavalca@fedoraproject.org> 0.8.1-1
- Initial import; Fixes: RHBZ#2023856
